"""Pyplan Engine URL Configuration
"""
from django.urls import path

from pyplan_engine.model import views

urlpatterns = [
    path('createNewModel/<uid>', views.createNewModel),
    path('openModel/<uid>', views.openModel),
    path('closeModel/<uid>', views.closeModel),
    path('saveModel/<uid>', views.saveModel),
    path('exportModule/<uid>', views.exportModule),
    path('importModule/<uid>', views.importModule),
    path('getDiagram/<uid>', views.getDiagram),
    path('getArrows/<uid>', views.getArrows),
    path('getBreadcrumb/<uid>', views.getBreadcrumb),

    path('searchNodes/<uid>', views.searchNodes),
    path('moveNodes/<uid>', views.moveNodes),
    path('copyNodes/<uid>', views.copyNodes),
    path('createInputNodes/<uid>', views.createInputNodes),
    path('createAlias/<uid>', views.createAlias),
    path('createNode/<uid>', views.createNode),
    path('deleteNodes/<uid>', views.deleteNodes),
    path('copyAsValues/<uid>', views.copyAsValues),
    path('setNodeIdFromTitle/<uid>', views.setNodeIdFromTitle),


    path('getModelProperties/<uid>', views.getModelProperties),
    path('setModelProperties/<uid>', views.setModelProperties),
    path('getNodeProperties/<uid>', views.getNodeProperties),
    path('setNodeProperties/<uid>', views.setNodeProperties),
    path('existNode/<uid>', views.existNode),
    path('isChild/<uid>', views.isChild),
    path('getInputs/<uid>', views.getInputs),
    path('getOutputs/<uid>', views.getOutputs),
    path('getDefinition/<uid>', views.getDefinition),
    path('invalidateNode/<uid>', views.invalidateNode),
    path('previewNode/<uid>', views.previewNode),
    path('profilenode/<uid>', views.profilenode),
    path('evaluate/<uid>', views.evaluate),
    path('callFunction/<uid>', views.callFunction),
    path('evaluateNode/<uid>', views.evaluateNode),
    path('executeButton/<uid>', views.executeButton),
    path('getIndexes/<uid>', views.getIndexes),
    path('getIndexesWithLevels/<uid>', views.getIndexesWithLevels),

    path('isTable/<uid>', views.isTable),
    path('isSelector/<uid>', views.isSelector),
    path('getSelector/<uid>', views.getSelector),
    path('getIndexType/<uid>', views.getIndexType),
    path('getIndexValues/<uid>', views.getIndexValues),
    path('setNodeValueChanges/<uid>', views.setNodeValueChanges),
    path('isCalcNodes/<uid>', views.isCalcNodes),
    path('exportFlatNode/<uid>', views.exportFlatNode),
    path('dumpNodeToFile/<uid>', views.dumpNodeToFile),
    path('loadScenario/<uid>', views.loadScenario),
    path('unloadScenario/<uid>', views.unloadScenario),
    path('geoUnclusterData/<uid>', views.geoUnclusterData),

    path('getCubeMetadata/<uid>', views.getCubeMetadata),
    path('getCubeDimensionValues/<uid>', views.getCubeDimensionValues),
    path('getCubeValues/<uid>', views.getCubeValues),
    path('getToolbars/<uid>', views.getToolbars),
    path('callWizard/<uid>', views.callWizard),
    path('getPID/<uid>', views.getPID),
    path('getSystemResources/<uid>', views.getSystemResources),
    path('installLibrary/<uid>', views.installLibrary),
    path('getInstallProgress/<uid>', views.getInstallProgress),
]
